<?php

/**
 * Class Login
 *
 * Please note:
 * Don't use the same name for class and method, as this might trigger an (unintended) __construct of the class.
 * This is really weird behaviour, but documented here: http://php.net/manual/en/language.oop5.decon.php
 *
 */
class Login extends Controller
{
    /**
     * PAGE: index
     * This method handles login page
     */
    public function index()
    {
        session_start();
        if (isset($_SESSION['valid'])) {
            header('Location: ' . DEFAULT_URL);
        } else {
            $title = 'Login';
            require 'application/views/login/index.php';
        }
    }

    /**
     * PAGE: authenticate
     * This method handles login authentication
     */
    public function authenticate()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST')
        {
            try {
                if (isset($_POST["username"]) && !empty($_POST["username"])) { 
                    $login_model = $this->loadModel('LoginModel');
                    $login_model->authenticateUser($_POST["username"], $_POST["password"]);
                }
                else{
                    header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
                    echo json_encode(array('error' => 'Invalid request.'));
                }
            } catch (Throwable $e) {
                header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
                echo json_encode(array('error' => $e->getMessage()));
            }
        }
        else {
            header($_SERVER['SERVER_PROTOCOL'] . ' 400 Bad Request', true, 400);
            exit;
        }
    }

    /**
     * PAGE: logout
     * This method handles user logout
     */
    public function logout()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST')
        {
            try {
                $login_model = $this->loadModel('LoginModel');
                $login_model->logout();
            } catch (Throwable $e) {
                header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
                echo json_encode(array('error' => $e->getMessage()));
            }
        }
        else {
            header($_SERVER['SERVER_PROTOCOL'] . ' 400 Bad Request', true, 400);
            exit;
        }
    }
}
