<?php

//** Clean input string */
class Utilities
{
    static function cleanInput ($data)
    {
        try {
            $data = trim($data);
            $data = stripslashes($data);
            $data = htmlspecialchars($data);
            return $data;
        } catch (Throwable $e) {
            throw new Exception($e);
        }
    }

    /**
     * Set Session
     * @param string $username username
     * @param string $user_type user_type
     */
    static function setSession($username, $userType)
    {
        try {
            
            session_start();
            $_SESSION['valid'] = true;
            $_SESSION['timeout'] = time();
            $_SESSION['username'] = $username;
            $_SESSION['user_type'] = $userType;

        } catch (Throwable $e) {
            throw new Exception($e);
        }
    }

    /**
     * Clear Session
     */
    static function clearSession()
    {
        try {
            session_start();
            unset($_SESSION['valid']);
            unset($_SESSION['timeout']);
            unset($_SESSION['username']);
            unset($_SESSION['user_type']);
        } catch (Throwable $e) {
            throw new Exception($e);
        }
    }
}