(function ($) {
    var baseUrl;

    $.login = {
        init: function(url) {
            baseUrl = url;
            $.login.initValidation();
        },
        initValidation: function() {
            var loginForm = $("#login_form").validate({
                rules: {
                    username: {
                        required: true
                    },
                    password: {
                        required: true
                    }
                },
                messages: {
                    username: {
                        required: "Please enter a username"
                    },
                    password: {
                        required: "Please provide a password"
                    }
                },
                submitHandler: function () {
                    var data = $.login.constructLoginModel();
                    $.login.authenticate(data);
                }
            });
        },
        constructLoginModel: function() {
            var data = {
                'username': $('#username').val(),
                'password': $('#password').val()
            };

            return data;
        },
        authenticate: function(data) {
            $.ajax({
                url: baseUrl + "login/authenticate",
                type: "post",
                data: data,
                success: function (response) {
                    if (response == 'valid')
                    {
                        window.location = baseUrl + 'users';
                    }   
                    else
                    {
                        var n = response.indexOf("USER_ERR-207");
                        var isError = false;
    
                        if (n > -1)
                        {
                            isError = true;
                            swal("Oops...", "Invalid username or password.", "error");
                        }
    
                        if(!isError) {
                            swal("Oops...", "Something went wrong!", "error");
                        }
                    }
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    var response = jQuery.parseJSON(jqXHR.responseText);

                    if(response != null)
                    {
                        var n = response.error.indexOf("USER_ERR-207");
                        var isError = false;

                        if (n > -1)
                        {
                            isError = true;
                            swal("Oops...", "Invalid username or password.", "error");
                        }

                        if(!isError) {
                            swal("Oops...", "Something went wrong!", "error");
                        }
                    }
                    else{
                        swal("Oops...", "Something went wrong!", "error");
                    }
                }
            });
        }
    };

})(window.jQuery);